/*
	nombre: EJEM-10_22.c
	libro: programacin en c, captulo 10.5: asignacin de memoria Dinmica.
	paginas: 372-375.
	Descripcin: Suma de dos tablas de nmeros, es decir; que realiza la suma de dos matrices de mxn en general
				 recordar que la suma de matrices se realiza entrada por entrada, el tamao de las matrices 
				 es determina por el usuario (definicin de arrays bidimenciones dinmicos).
				 Cada array bidimencional se procesa como puntero a un conjunto de arrayas unidimencionales de
				 enteros.
*/

#include <stdio.h>
#include <stdlib.h>

#define MAXFIL 20

// prototipo de funiones.
void leerEntrada( int *a[MAXFIL], int nFilas, int nCols );
void calcularSuma( int *a[MAXFIL], int *b[MAXFIL], int *c[MAXFIL], int nFilas, int nCols );
void escribirSalida( int *c[MAXFIL], int nFilas, int nCols );

int main( void ){
	int fila, nFilas, nCols;
//	Definiciones de punteros.
	int *a[MAXFIL], *b[MAXFIL], *c[MAXFIL];

	printf("Cuantas filas: "); scanf("%i", &nFilas);
	printf("Cuantas columnas: "); scanf("%i", &nCols);
	
// reserva inicial de memoria.
	for( fila = 0; fila < nFilas; ++fila ){
		
		a[fila] = (int *) malloc( nCols * sizeof( int ) );
		b[fila] = (int *) malloc( nCols * sizeof( int ) );
		c[fila] = (int *) malloc( nCols * sizeof( int ) );
		
	}// Fin desde fila.
	
	printf("\n\nPrimera tabla:\n");
	leerEntrada( a, nFilas, nCols );
	
	printf("\n\nSegunda tabla:\n");
	leerEntrada( b, nFilas, nCols );
	
	calcularSuma( a, b, c, nFilas, nCols );
	
	printf("\n\nSumas de los elementos:\n\n");
	escribirSalida( c, nFilas, nCols );
	
printf("\n\n"); system("pause"); return 0;}

// Leer la tabla de enteros.
void leerEntrada( int *a[MAXFIL], int m, int n ){
	int fila, col;
	
	for( fila = 0; fila < m; ++fila ){
		
		printf("\nIntroducir datos para la fila n %i: ", fila + 1);
		for( col = 0; col < n; ++col ){
			
			scanf("%i", ( *(a + fila) + col) );
			
		}// Fin desde col.
		
	}// Fin desde fila.
	
}// Fin funcin leerEntrada.

// Sumar los elementos de dos tablas de enteros.
void calcularSuma( int *a[MAXFIL], int *b[MAXFIL], int *c[MAXFIL], int m, int n ){
	int fila, col;
	
	for( fila = 0; fila < m; ++fila ){
		
		for( col = 0; col < n; ++col ){
			
			*( *(c + fila) + col ) = *( *(a + fila) + col ) + *( *(b + fila) + col );
			
		}// fin desde col.
		
	}// fin desde fila.
	
}// Fin de funcin calcularSuma.

// Escribir una tabla de enetros.
void escribirSalida( int *a[MAXFIL], int m, int n ){
	int fila, col;
	
	for( fila = 0; fila < m; ++fila ){
		
		for( col = 0; col < n; ++col ){
			
			printf("%i", *( *(a + fila) + col ));
			
		}// Fin desde col.
		
	}// Fin desde fila.
	
}// Fin funcin escribirSalida.
